
var nsFile = {
	readFile : function (str_Filename)
	{ 
		try{
           var obj_File = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
           obj_File.initWithPath(str_Filename);
 
           var obj_InputStream =  Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
           obj_InputStream.init(obj_File,0x01,0444,null);
 
           var obj_ScriptableIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
           obj_ScriptableIO.init(obj_InputStream);
        } catch (e) { alert(e); }
 
        try {
                var str = obj_ScriptableIO.read(obj_File.fileSize-1);
        } catch (e) { dump(e); }
        obj_ScriptableIO.close();
        obj_InputStream.close();
        return str;
	},
	
	//Checks if file exists
	exists : function (str_Filename) {
		var obj_File = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		obj_File.initWithPath(str_Filename);
		return obj_File.exists()
			
	},
	
	//Write a string to a file
	writeFile : function (str_Buffer, str_Filename)
	{	
		try {
			var obj_File = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			obj_File.initWithPath(str_Filename);
			
			//Attempt to create it if it doesn't exist
			if (!obj_File.exists()) {
				obj_File.create(0x00,0755);
			}
			
			var obj_OutputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );
			obj_OutputStream.init( obj_File, 0x04 | 0x08 | 0x20, 420, 0 );
			obj_OutputStream.write(str_Buffer, str_Buffer.length);
			obj_OutputStream.flush()
			obj_OutputStream.close();
		} catch (e) {
			alert(e)
		}
	},
	
}