var vars={};
var inputs_src='';
function openWizard(theForm)
{
  var document=theForm.ownerDocument;
  vars.method=theForm.method == '' ? 'get' : theForm.method;//default is get
  if(vars.method.toLowerCase() != 'get') alert('The method of this form is not \"get\".\n'+
                                                'this program may not working');
  vars.action=theForm.action;
  vars.searchForm=document.URL;
  vars.queryCharset=document.characterSet;
  window.openDialog("chrome://search_engine_wizard/content/searchPlugWizard.xul",
              "Wizard",
	      "chrome,resizable,dependent,dialog,minimizable=0,alwaysRaised",
	      vars);
}

/*
base:
http://www.w3.org/TR/html4/interact/forms.html#h-17.13

not considering elements:
OBJECT, IMAGE
*/
function paringForm(user)
{
  var form=user.form;
  var successful_controls=new Array();
  var submits_num = 0;
  var theOne={};
  var submits=new Array();
//finding all submits** start
  for(var i = 0; i < form.elements.length; i++)
  {
    var tmp = form.elements[i];

    if(tmp.type.toLowerCase() == 'submit'){
       submits_num++;
       theSubmit = tmp;
       submits[submits.length] = tmp;
    }

  }
//finding all submits** end  
  if(submits_num > 1){//decide the only one submit button
	  var msg = 'There\'re more than 1 submit buttons, so you need to choose one.\n'+
	            'Please input the number 1' + '-' + submits.length + '\n';
	  for(var i = 0; i < submits_num; i++){
		  msg += ('button ' + (i + 1) +' : '+ submits[i].value + '\n');
	  }
	  for(;;){
		  var which = parseInt(window.prompt(msg, 1), 10);
		  if(which >= 1 && which <= submits.length){
			  theSubmit = submits[which - 1];
			  if(window.confirm('button ' + which +' : '+ theSubmit.value + '?')){
				  break;
			  }  
		  }
	  }
  }
  
  for(var i = 0; i < form.elements.length; i++)
  {
    var tmp=form.elements[i];
    if(typeof(tmp.type)=='undefined' || tmp.disabled || typeof(tmp.name)=='undefined' || tmp.name=='')
    {
            continue;
    }
    if(tmp.isSameNode(user)){
	    successful_controls[successful_controls.length] = '<input name=\"' + user.name + '\" user>';
    }
    else if(tmp.isSameNode(theSubmit)){
	    successful_controls[successful_controls.length] = '<input name=\"' + tmp.name + '\" value=\"' +
                                                              tmp.value + '\">';
    }
    else{
      switch(tmp.type)
      {
        case 'button':
        case 'file':
        case 'submit':
        case 'image':
        case 'reset': break;

        case 'checkbox':
        case 'radio':
        {
          if(tmp.checked)
	  {
            successful_controls[successful_controls.length] = '<input name=\"' + tmp.name + '\" value=\"' +
                                    tmp.value + '\">';
          }
          break;
        }
		

        case 'select-multiple':
        {
          for(var j=0; j<tmp.options.length; j++)
	  {
            if(tmp.options[j].disabled) continue;
            if(tmp.options[j].selected)
	    {
              successful_controls[successful_controls.length] = '<input name=\"' + tmp.name + '\" value=\"' +
                                      tmp.options[j].value + '\">';
            }
          }
          break;
        }
		
        case 'select-one':
        case 'hidden':
        case 'text':
        case 'password':
        case 'textarea':
        default:
        {
          successful_controls[successful_controls.length] = '<input name=\"' + tmp.name + '\" value=\"' +
                                  tmp.value + '\">';
        }
      }
    }
  }
  inputs_src = successful_controls.join('\n');
  inputs_src += '\n' + '<input name=\"sourceid\" value=\"mozilla-search\">';

  
}


function startWizard(user)
{
	if(typeof(user.form) == 'undefined') return;
	switch(user.type.toLowerCase())
	{//limits
		case 'file':
		case 'submit':
		case 'reset':
		case 'image':
		case 'button': return;
	}

  paringForm(user);
  openWizard(user.form);
}
